Bug 438867 - dwfl_end croaks if kernel debuginfo found but no kernel proper
dwfl_end croaks if kernel debuginfo found but no kernel proper
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: elfutils (Show other bugs)
9
All Linux
low Severity medium
: ---
: ---
Assigned To: Roland McGrath
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-03-25 13:35 EDT by Frank Ch. Eigler
Modified: 2009-07-15 04:25 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-15 04:25:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frank Ch. Eigler 2008-03-25 13:35:05 EDT
Run stap -e 'probe kernel.function("sys_open") {}'
with kernel-debuginfo installed, but without the same kernel RPM.
stap will segv within dwfl_end.  A way to simulate it is just to
rename the /lib/modules/`uname -r` directory briefly.

The lowest-level problem is that dwfl->nmodules == 1 even as
dwfl->modules==NULL.


Pass 1: parsed user script and 38 library script(s) in 340usr/10sys/360real ms.
semantic error: libdwfl failure (missing kernel 2.6.18-53.1.13.el5 ppc64
debuginfo): No such file or directory while resolving probe point
kernel.function("sys_open")

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 552390915504 (LWP 1659)]
0x000004000001b814 in dwfl_end (dwfl=0x109df520)
    at elfutils-0.131/libdwfl/dwfl_end.c:58
58      elfutils-0.131/libdwfl/dwfl_end.c: No such file or directory.
        in elfutils-0.131/libdwfl/dwfl_end.c
Current language:  auto; currently c
(gdb) bt
#0  0x000004000001b814 in dwfl_end (dwfl=0x109df520)
    at elfutils-0.131/libdwfl/dwfl_end.c:58
#1  0x00000000100b1f44 in ~dwflpp (this=0x109df790) at tapsets.cxx:1995
#2  0x00000000100b23ac in dwarf_builder::build_no_more (this=0x109de040, 
    s=@0xfffff8ce618) at tapsets.cxx:2308
#3  0x000000001003f894 in match_node::build_no_more (this=0x109de460, 
    s=@0xfffff8ce618) at elaborate.cxx:427
#4  0x000000001003f84c in match_node::build_no_more (this=0x109de360, 
    s=@0xfffff8ce618) at elaborate.cxx:426
#5  0x000000001003f84c in match_node::build_no_more (this=0x109de060, 
    s=@0xfffff8ce618) at elaborate.cxx:426
#6  0x000000001003f84c in match_node::build_no_more (this=0x10120240, 
    s=@0xfffff8ce618) at elaborate.cxx:426
#7  0x00000000100499a8 in semantic_pass_symbols (s=@0xfffff8ce618)
    at elaborate.cxx:1155
#8  0x000000001004e450 in semantic_pass (s=@0xfffff8ce618)
    at elaborate.cxx:1172
#9  0x000000001000c1cc in main (argc=-7541744, argv=<value optimized out>)
    at main.cxx:719
#10 0x000000809d159700 in generic_start_main (
    main=@0x10116668: 0x10009950 <main>, argc=0, ubp_av=0xfffff8cf878, 
    auxvec=0xfffff8cf9a8, init=<value optimized out>, fini=dwarf2_read_address:
Corrupted DWARF expression.
)
    at ../csu/libc-start.c:231
#11 0x000000809d159980 in __libc_start_main (argc=5, ubp_av=0xfffff8cf878, 
    ubp_ev=<value optimized out>, auxvec=0xfffff8cf9a8, 
    rtld_fini=@0x809d100370: 0x809d0da390 <_dl_fini>, stinfo=0x1010c978, 
    stack_on_entry=0xfffff8cf7f0)
    at ../sysdeps/unix/sysv/linux/powerpc/libc-start.c:127
#12 0x0000000000000000 in ?? ()
(gdb) frame 0
#0  0x000004000001b814 in dwfl_end (dwfl=0x109df520)
    at elfutils-0.131/libdwfl/dwfl_end.c:58
58      in elfutils-0.131/libdwfl/dwfl_end.c
(gdb) p dwfl
$1 = (Dwfl *) 0x109df520
(gdb) p *dwfl
$2 = {callbacks = 0x10110bb8, modulelist = 0x109df8a0, modules = 0x0, 
  nmodules = 1, offline_next_address = 65536}
(gdb) p *dwfl->modulelist
$3 = {dwfl = 0x109df520, next = 0x0, userdata = 0x0, 
  name = 0x109df9c0 "kernel", low_addr = 13835058055282163712, 
  high_addr = 13835058055289238672, build_id_bits = 0x0, build_id_vaddr = 0, 
  build_id_len = 0, main = {
    name = 0x109df9e0 "/usr/lib/debug/lib/modules/2.6.18-53.1.13.el5/vmlinux", 
    fd = 6, valid = false, relocated = false, elf = 0x109dfa60, bias = 0}, 
  debug = {name = 0x0, fd = 0, valid = false, relocated = false, elf = 0x0, 
    bias = 0}, ebl = 0x0, e_type = 3, elferr = DWFL_E_NOERROR, 
  reloc_info = 0x0, symfile = 0x0, symdata = 0x0, syments = 0, 
  symstrdata = 0x0, symxndxdata = 0x0, symerr = DWFL_E_NOERROR, dw = 0x0, 
  dwerr = DWFL_E_NOERROR, first_cu = 0x0, cu = 0x0, ncu = 0, 
  lazy_cu_root = 0x0, lazycu = 0, aranges = 0x0, naranges = 0, gc = false}
(gdb) p i
$4 = 0
(gdb) p *dwfl->modules
Cannot access memory at address 0x0
(gdb) p *dwfl
$6 = {callbacks = 0x10110bb8, modulelist = 0x109df8a0, modules = 0x0, 
  nmodules = 1, offline_next_address = 65536}
(gdb) p dwfl->nmodules
$7 = 1
Comment 1 Roland McGrath 2008-03-26 15:50:04 EDT
Fixed upstream.
Comment 2 Bug Zapper 2008-05-14 02:50:34 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Fedora Update System 2008-05-21 15:48:58 EDT
elfutils-0.135-1.fc7 has been submitted as an update for Fedora 7
Comment 4 Fedora Update System 2008-05-21 15:51:19 EDT
elfutils-0.135-1.fc8 has been submitted as an update for Fedora 8
Comment 5 Fedora Update System 2008-05-21 15:52:56 EDT
elfutils-0.135-1.fc9 has been submitted as an update for Fedora 9
Comment 6 Fedora Update System 2008-05-28 22:39:50 EDT
elfutils-0.135-1.fc7 has been pushed to the Fedora 7 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update elfutils'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F7/FEDORA-2008-4457
Comment 7 Fedora Update System 2008-07-30 16:08:27 EDT
elfutils-0.135-1.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 8 Fedora Update System 2008-07-30 16:11:31 EDT
elfutils-0.135-1.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 9 Bug Zapper 2009-06-09 19:50:56 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2009-07-15 04:25:52 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.